# Get the LCG platform tag (e.g. slc3-i386-gcc4) for the
# current platform and set it to the $LCG_TAG variable.
# Based on the Genser platform detection script.
#AC_LCG_TAG()
#----------------------------------------
AC_DEFUN([AC_LCG_TAG], [
  AC_MSG_CHECKING([for OS type])
  distribution=`uname`
  if test -s "/etc/redhat-release"; then
    distribution="redhat" 
    sltest=`lsb_release -ds | grep "Scientific Linux"`
    if test "x$sltest" != x; then
      slc_major=`lsb_release -rs | cut -f1 -d.`
      distribution="slc${slc_major}"
    fi
  fi
  AC_MSG_RESULT($distribution)
  dnl AC_MSG_NOTICE([The OS is not RedHat-derived - LCG tag may be non-standard])
  dnl AC_MSG_NOTICE([The OS is not SLC - LCG tag may be non-standard])

  AC_MSG_CHECKING([for architecture type])
  [machine32=`uname -m | grep -E "i[3456]86"`]
  [machine64=`uname -m | grep "x86_64"`]
  machine="ia32"
  if test "x$machine32" != x; then machine="ia32"; fi 
  if test "x$machine64" != x; then machine="amd64"; fi
  AC_MSG_RESULT([$machine])

  AC_MSG_CHECKING([for gcc/g++ version])
  gcc_version=`g++ --version | head -1 | cut -d" " -f3`
  gcc_major=`echo $gcc_version | cut -d. -f1`
  gcc_minor=`echo $gcc_version | cut -d. -f2`
  gcc_micro=`echo $gcc_version | cut -d. -f3`
  gcc_code="gcc${gcc_major}${gcc_minor}"
  AC_MSG_RESULT([$gcc_code])

  LCG_TAG="${distribution}_${machine}_${gcc_code}"
  AC_SUBST(LCG_TAG)
  AC_MSG_NOTICE([LCG platform is ${LCG_TAG}])
])
